# operator&,|,^(std::bitset)

From cppreference.com
< cpp‎ | utility‎ | bitset

template< std::size_t N > bitset<N> operator&( const bitset<N>& lhs, const bitset<N>& rhs ); | (1) |
template< std::size_t N > bitset<N> operator|( const bitset<N>& lhs, const bitset<N>& rhs ); | (2) |
template< std::size_t N > bitset<N> operator^( const bitset<N>& lhs, const bitset<N>& rhs ); | (3) |

Performs binary AND, OR, and XOR between two bitsets, `lhs` and `rhs`.

1) Returns a `bitset<N>` containing the result of binary AND on corresponding pairs of bits of `lhs` and `rhs`.
2) Returns a `bitset<N>` containing the result of binary OR on corresponding pairs of bits of `lhs` and `rhs`.
3) Returns a `bitset<N>` containing the result of binary XOR on corresponding pairs of bits of `lhs` and `rhs`.

### Parameters

lhs | - | the bitset on the left-hand side of the operator
rhs | - | the bitset on the right-hand side of the operator

### Return value

1) bitset<N>(lhs) &= rhs
2) bitset<N>(lhs) |= rhs
3) bitset<N>(lhs) ^= rhs

### Exceptions

(none) | (until C++11)
`noexcept` specification: noexcept | (since C++11)

### Example

Run this code

    #include <bitset>
    #include <iostream>

    int main()
    {
        std::bitset<4> b1("0110");
        std::bitset<4> b2("0011");
        std::cout << "b1 & b2: " << (b1 & b2) << '\n';
        std::cout << "b1 | b2: " << (b1 | b2) << '\n';
        std::cout << "b1 ^ b2: " << (b1 ^ b2) << '\n';
    }

Output:

    b1 & b2: 0010
    b1 | b2: 0111
    b1 ^ b2: 0101

### See also

operator&=operator|=operator^=operator~ | performs binary AND, OR, XOR and NOT (public member function)

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/utility/bitset/operator_logic2&oldid=91722"
Category:

- unconditionally noexcept

Hidden categories:

- Pages with unreviewed unconditional noexcept template
- Pages with unreviewed noexcept template